#include "Cover.h"

using namespace std;

extern std::vector< boost::dynamic_bitset<> > Vertical_DataBase;
extern std::vector< boost::dynamic_bitset<> > Horizontal_DataBase;

/// Compute initial cover (all transaction)
void Cover::Initial_Cover(){ 	
  for (unsigned int i = 0; i < Vertical_DataBase[0].size(); i++) {
	Liste_Cover.push_back(i); // all "id" of transactions 
  }    
}

/// Compute cover incrementaly using previous covers
void Cover::Compute_New_Cover(vector <int> item_prefix, Cover *nextCover){  
	int trans_ = Vertical_DataBase[0].size();	
	for (unsigned int i = 0; i < Liste_Cover.size(); i++){ // For each transaction of Cover 
		int flag = 1;
		for(int j=0; ((j<item_prefix.size()) && (flag==1)); j++) { // new item(s) of sigma_1
			if ( Vertical_DataBase[item_prefix[j]-1][Liste_Cover[i]] == 0 ){ // if an item isn't in transaction => don't take the transaction
				flag = 0;
				break;		
			}
		}
		if (flag == 1) // transaction include the item
			nextCover->Liste_Cover.push_back(Liste_Cover[i]);	// add this id's transation to new cover			  
	}
}

/// Compute inclusions test : case p_k = 0 && sum = 0
void Cover::Inclusion_test_00(vector <int> sigma_0_new, vector <int> sigma_01){
	
	bool dominer = true; // flag
	Inclusion.clear(); // clean at each call, because it's the same object, we don't compute a new cover when p_k = 0
	/*for (unsigned int i = 0; i < sigma_01.size(); i++){
		for (unsigned int j = 0; j < sigma_0_new.size(); j++){
			dominer = true;				
			for (unsigned int k = 0; k < Vertical_DataBase[0].size(); k++){ // for each id in cover (here the cover is initial)	
				// if  (j = 0 && i = 1) => i isn't included in j					
				if ((( Vertical_DataBase[sigma_0_new[j]-1][k] == 0) && ( Vertical_DataBase[sigma_01[i]-1][k] == 1))){
					dominer = false;
					break;		
				}											
			}
			if(dominer){
				Inclusion.push_back(sigma_01[i]); // Add this item
				sigma_0_new.push_back(sigma_01[i]); // Update sigma_0	
				break;
			}					
		}										
	}*/
	
	//--- V2 : version avec boucles inversées ---//
	int sigma_0_new_size = sigma_0_new.size();
	int sigma_01_size = sigma_01.size();
	for (unsigned int i = 0; i < sigma_0_new_size; i++){
		for (unsigned int j = 0; j < sigma_01_size; j++){
			dominer = true;	 // i domine j jusqu'a preuve du contraire			
			for (unsigned int k = 0; k < Vertical_DataBase[0].size(); k++){ // for each id in cover (here the cover is initial)	
				// if  (i = 0 && j = 1) => j isn't included in i					
				if ((( Vertical_DataBase[sigma_0_new[i]-1][k] == 0) && ( Vertical_DataBase[sigma_01[j]-1][k] == 1))){
					dominer = false;
					break;	// sortir de la boucle sur les transactions	
				}											
			}
			if(dominer){
				Inclusion.push_back(sigma_01[j]); // Add this item
				sigma_0_new.push_back(sigma_01[j]); // Update sigma_0 en y ajoutant l'item j	
				// Update sigma_01 en y retirant l'item i
				if (find(sigma_01.begin(), sigma_01.end(), sigma_01[j]) == sigma_01.end()){ 
					sigma_01.erase(std::remove(sigma_01.begin(), sigma_01.end(), sigma_01[j]), sigma_01.end());
					break;
				}		
				sigma_0_new_size++;
				sigma_01_size--;
			}					
		}										
	}
}

/// Compute inclusions test : case p_k = 0 && sum > 0 (we have the frequency of each item)
void Cover::Inclusion_test_0(int minF, vector <int> sigma_0_new, vector <int> sigma_01){
	int Somme_V_j, Somme_V_i = 0;	
	bool dominer = true;
	Inclusion.clear(); // clean at each call, because it's the same object, we don't campute a new cover when p_k = 0	
	/*for (unsigned int i = 0; i < sigma_01.size(); i++){
		for (unsigned int j = 0; j < sigma_0_new.size(); j++){
		// if the frequency of items (i,j) are >= minsup and que freq_j >= freq_i => look for inclusion (j => i)
			if ((Frequency[sigma_01[i]-1] >= minF) && (Frequency[sigma_0_new[j]-1] >= minF) && (Frequency[sigma_0_new[j]-1] >= Frequency[sigma_01[i]-1])){
				Somme_V_j, Somme_V_i = 0;
				dominer = true;							
				for (unsigned int k = 0; k < Liste_Cover.size(); k++){ // For each id in cover		
					Somme_V_i += Vertical_DataBase[sigma_01[i]-1][Liste_Cover[k]]; // |V_i| 
					Somme_V_j += Vertical_DataBase[sigma_0_new[j]-1][Liste_Cover[k]];  // |V_j|		
					// if  (j = 0 && i = 1) or ( |V_j| = freq_j && |V_i| < freq_i ) => i isn't included in j					
					if ((( Vertical_DataBase[sigma_0_new[j]-1][Liste_Cover[k]] == 0) && ( Vertical_DataBase[sigma_01[i]-1][Liste_Cover[k]] == 1)) || 
					((Somme_V_j == Frequency[sigma_0_new[j]-1]) && (Somme_V_i < Frequency[sigma_01[i]-1]))){
						dominer = false;
						break;		
					}											
				}				
				if(dominer){
					Inclusion.push_back(sigma_01[i]); //add this item
					sigma_0_new.push_back(sigma_01[i]); // Update sigma_0			
					break;
				}
			}							
		}										
	}*/
	
	//--- V2 : version avec boucles inversées ---//
	int sigma_0_new_size = sigma_0_new.size();
	int sigma_01_size = sigma_01.size();
	for (unsigned int i = 0; i < sigma_0_new_size; i++){
		for (unsigned int j = 0; j < sigma_01_size; j++){
			// if the frequency of items (i,j) are >= minsup and que freq_j >= freq_i => look for inclusion (j => i)
			if ((Frequency[sigma_0_new[i]-1] >= minF) && (Frequency[sigma_01[j]-1] >= minF) && (Frequency[sigma_0_new[i]-1] >= Frequency[sigma_01[j]-1])){
				Somme_V_j, Somme_V_i = 0;
				dominer = true;	 // i domine j jusqu'a preuve du contraire			
				for (unsigned int k = 0; k < Liste_Cover.size(); k++){ // for each id in cover (here the cover is initial)	
					Somme_V_i += Vertical_DataBase[sigma_0_new[i]-1][Liste_Cover[k]]; // |V_i| 
					Somme_V_j += Vertical_DataBase[sigma_01[j]-1][Liste_Cover[k]];  // |V_j|	
					// if  (i = 0 && j = 1) => j isn't included in i					
					if ((( Vertical_DataBase[sigma_0_new[i]-1][Liste_Cover[k]] == 0) && ( Vertical_DataBase[sigma_01[j]-1][Liste_Cover[k]] == 1)) ||
					((Somme_V_i == Frequency[sigma_0_new[i]-1]) && (Somme_V_j < Frequency[sigma_01[j]-1]))){
						dominer = false;
						break;	// sortir de la boucle sur les transactions	
					}											
				}
				if(dominer){
					Inclusion.push_back(sigma_01[j]); // Add this item
					sigma_0_new.push_back(sigma_01[j]); // Update sigma_0 en y ajoutant l'item j	
					// Update sigma_01 en y retirant l'item i
					if (find(sigma_01.begin(), sigma_01.end(), sigma_01[j]) == sigma_01.end()){ 
						sigma_01.erase(std::remove(sigma_01.begin(), sigma_01.end(), sigma_01[j]), sigma_01.end());
						break;
					}				
					sigma_0_new_size++;
					sigma_01_size--;
				}					
			}										
		}
	}
}

/// Compute : (no frequent items) + (full extension items) + (items included in items of sigma_0)
void Cover::Frequent_Closed_Itemsets(int minF, vector <int> sigma_1, vector <int> sigma_0, vector <int> sigma_01){
	int sigma_0_size = sigma_0.size();
	int sigma_01_size = sigma_01.size();
	int Somme_V_j, Somme_V_i = 0;	
	bool dominer = true;
	//----------------------------------------------------------
	// Update Frequency + Get Not Frequents Items + Closure Operation
	//----------------------------------------------------------
	for (unsigned int i = 0; i < Vertical_DataBase.size(); i++){
		 
		Frequency.push_back(0);
		// Consider only items in sigma_01 and sigma_0
		if (find(sigma_1.begin(), sigma_1.end(), i+1) == sigma_1.end()){ 
			// Compute frequency of item 'i'
			for (unsigned int j = 0; j < Liste_Cover.size(); j++){	// for each id in cover
				Frequency[i] += Vertical_DataBase[i][Liste_Cover[j]];
			}
			// items with frequency = |P| (full extension) add to Closure set
			if (Frequency[i] == Liste_Cover.size()){
				Closure.push_back(i+1);					
				sigma_1.push_back(i+1); // Update sigma_1
				// Update sigma_01/sigma_0 en y retirant l'item i
				/*if (find(sigma_01.begin(), sigma_01.end(), i+1) == sigma_01.end()){ 
					sigma_01.erase(std::remove(sigma_01.begin(), sigma_01.end(), i+1), sigma_01.end());
					sigma_01_size--;
					break;
				}
				if (find(sigma_0.begin(), sigma_0.end(), i+1) == sigma_0.end()){ 
					sigma_0.erase(std::remove(sigma_0.begin(), sigma_0.end(), i+1), sigma_0.end());
					sigma_0_size--;
					break;
				}*/								
			}
			// items with frequency < minSup => add to NotFreqIt set
			else if ( Frequency[i] < minF ){
				NotFreqItems.push_back(i+1);				
				sigma_0.push_back(i+1); // Update
				// Update sigma_01/sigma_0 en y retirant l'item i				
				/*if (find(sigma_01.begin(), sigma_01.end(), i+1) == sigma_01.end()){ 
					sigma_01.erase(std::remove(sigma_01.begin(), sigma_01.end(), i+1), sigma_01.end());
					break;				
				}*/
				//sigma_0_size++;
				//sigma_01_size--;
			}
		}		 
	}
	//--------
	// items included in any item of sigma_0 : consider all items in sigma_01/sigma_1 because we have a new cover
	//---------		
	// for each item in sigma_01
	/*for (unsigned int i = 0; i < sigma_01.size(); i++){
		// for each item in sigma_0
		for (unsigned int j = 0; j < sigma_0.size(); j++){
			
			// if the frequency of items i,j are >= minsup and que freq_j >= freq_i => look for inclusion (j => i)
			if ((Frequency[sigma_01[i]-1] >= minF) && (Frequency[sigma_0[j]-1] >= minF) && (Frequency[sigma_0[j]-1] >= Frequency[sigma_01[i]-1])){
				
				Somme_V_j, Somme_V_i = 0;
				dominer = true;					
				for (unsigned int k = 0; k < Liste_Cover.size(); k++){ // for each id in cover
					
					Somme_V_i += Vertical_DataBase[sigma_01[i]-1][Liste_Cover[k]]; // |V_i|
					Somme_V_j += Vertical_DataBase[sigma_0[j]-1][Liste_Cover[k]];  // |V_j|					
						
					// if  (j = 0 && i = 1) or ( |V_j| = freq_j && |V_i| < freq_i ) => i isn't included in j			
					if ((( Vertical_DataBase[sigma_0[j]-1][Liste_Cover[k]] == 0) && ( Vertical_DataBase[sigma_01[i]-1][Liste_Cover[k]] == 1)) || 
					((Somme_V_j == Frequency[sigma_0[j]-1]) && (Somme_V_i < Frequency[sigma_01[i]-1]))){ 
						dominer = false;
						break;		
					}											
				}
				if(dominer){
					Inclusion.push_back(sigma_01[i]); // Add this item to inclusion set
					sigma_0.push_back(sigma_01[i]); // Update sigma_0	
					break;
				}							
			}
		}				
	}*/
	//--- V2 : version avec boucles inversées ---//
	for (unsigned int i = 0; i < sigma_0_size; i++){
		for (unsigned int j = 0; j < sigma_01_size; j++){
			// if the frequency of items (i,j) are >= minsup and que freq_j >= freq_i => look for inclusion (j => i)
			if ((Frequency[sigma_0[i]-1] >= minF) && (Frequency[sigma_01[j]-1] >= minF) && (Frequency[sigma_0[i]-1] >= Frequency[sigma_01[j]-1])){
				Somme_V_j, Somme_V_i = 0;
				dominer = true;	 	
				for (unsigned int k = 0; k < Liste_Cover.size(); k++){ // for each id in cover (here the cover is initial)	
					Somme_V_i += Vertical_DataBase[sigma_0[i]-1][Liste_Cover[k]]; // |V_i| 
					Somme_V_j += Vertical_DataBase[sigma_01[j]-1][Liste_Cover[k]];  // |V_j|	
					// if  (i = 0 && j = 1) => j isn't included in i					
					if ((( Vertical_DataBase[sigma_0[i]-1][Liste_Cover[k]] == 0) && ( Vertical_DataBase[sigma_01[j]-1][Liste_Cover[k]] == 1)) ||
					((Somme_V_i == Frequency[sigma_0[i]-1]) && (Somme_V_j < Frequency[sigma_01[j]-1]))){
						dominer = false;
						break;	// sortir de la boucle sur les transactions	
					}											
				}
				if(dominer){
					Inclusion.push_back(sigma_01[j]); // Add this item
					sigma_0.push_back(sigma_01[j]); // Update sigma_0 en y ajoutant l'item j	
					// Update sigma_01 en y retirant l'item i
					if (find(sigma_01.begin(), sigma_01.end(), sigma_01[j]) == sigma_01.end()){ 
						sigma_01.erase(std::remove(sigma_01.begin(), sigma_01.end(), sigma_01[j]), sigma_01.end());
						break;
					}				
					sigma_0_size++;
					sigma_01_size--;
				}					
			}										
		}
	}	
}

/// Function : Calcul des items non frequents + items Maximaux + items inclus dans un item de sigma_0
void Cover::Frequent_Maximal_Itemsets(int minF, vector <int> sigma_1, vector <int> sigma_0, vector <int> sigma_01){
	
	int nbr_items_free, nbr_transactions_maximale, transaction_size = 0;		
	// Compute Frequency + Get Not Frequents Items
	for (unsigned int i = 0; i < Vertical_DataBase.size(); i++){ // for each item
		Frequency.push_back(0);		
		if (find(sigma_1.begin(), sigma_1.end(), i+1) == sigma_1.end()){ // Les items ne doivent pas être dans sigma_1 => items \in sigma_01 + sigma_0
			
			for (unsigned int j = 0; j < Liste_Cover.size(); j++){ // Calculer la frequence de cet item 'i'
				Frequency[i] += Vertical_DataBase[i][Liste_Cover[j]];
			}
			if (Frequency[i] >= minF){
				Maximal.push_back(i+1);					
				//sigma_1.push_back(i+1);
			}
			// items dont la fréquence < minSup => Mettre dans NotFreqIt,
			else if ( Frequency[i] < minF )
				NotFreqItems.push_back(i+1);	
		}		 
	}
	
	//nbr_transactions_maximale = 0;...........
	// Détecter s'il existe au moins minsup transactions avec des 1 partout (full transaction)
	/*for (unsigned int i = 0; i < Liste_Cover.size(); i++){ // pour chaque trans
		
		nbr_items_free = 0;		
		transaction_size = 0;
		
		for(int j = 0; j < Vertical_DataBase.size(); j++) { // pour chaque item						
			if (find(sigma_1.begin(), sigma_1.end(), j+1) == sigma_1.end()){		
				nbr_items_free++;
				transaction_size += Horizontal_DataBase[Liste_Cover[i]][j];
			}			
		}
		// transaction dont la somme = Horizontal_DataBase[i].size()  => Mettre dans Maximal :
		if ( transaction_size == nbr_items_free){
			nbr_transactions_maximale++; 	
		}
		// tester combien de transactions sont maximales
		if(nbr_transactions_maximale >= minF){
			// mettre tous les items sauf ceux deja instanciés à 1 dans maximal
			for(unsigned int j=0; j < Vertical_DataBase.size(); j++) { // pour chaque item
				if (find(sigma_1.begin(), sigma_1.end(), j+1) == sigma_1.end()){
					Maximal.push_back(j+1);
				}
			}
			break;
		}	
	}*/
	
	int nombre_Intersections = 0;
	// items inclus dans un item de sigma_0		
	for (unsigned int i = 0; i < sigma_01.size(); i++){ // Pour chaque item dans sigma_01
		
		for (unsigned int j = 0; j < sigma_0.size(); j++){ // Pour chaque item dans sigma_0
			
			nombre_Intersections = 0;
			// Si les fréquences des items i,j sont supérieurs au minsup => chercher les implications (j => i)
			if ((Frequency[sigma_01[i]-1] >= minF) && (Frequency[sigma_0[j]-1] >= minF)){
				
				for (unsigned int k = 0; k < Liste_Cover.size(); k++){ // Pour chaque id dans Cover
					
					// si intersection
					if (( Vertical_DataBase[sigma_0[j]-1][Liste_Cover[k]] == 1) && ( Vertical_DataBase[sigma_01[i]-1][Liste_Cover[k]] == 1)){
						nombre_Intersections++; // Intersection des covers des deux items >= minsup
					}
					if (nombre_Intersections >= minF){
						Maximal_Inclusion.push_back(sigma_01[i]); 
						break;
					}
				}									
			}
		}				
	}
}

