#ifndef DEF_DATABASES
#define DEF_DATABASES

#include <sys/time.h>
#include <time.h>
#include <sys/resource.h>
#include <cstring>
#include <algorithm>
#include <map>
#include <string>
#include <fstream>
#include <math.h>
#include <iostream>
#include <sstream> 
#include <vector>
#include <bitset>
#include <stdio.h>
#include <boost/dynamic_bitset.hpp>

using namespace std;

typedef std::vector < int > VECELE;
typedef std::vector < VECELE > MATELE;

class DataBases {
	
	public:
	
		/// Attributs 
		vector < vector <int> > initial_DataBase; // original database 
		vector <int> Code; // encoding items
		vector < vector <int> > Processed_DataBase; // database after processing
		vector < vector <int> > Boolean_Base; // database with boolean
		vector< boost::dynamic_bitset<> > Horizontal_DataBase; // database horizontal H (bitset)
		vector< boost::dynamic_bitset<> > Vertical_DataBase; // datadase vertical V (bitset)
		
		/// Méthodes
		void GetData(string FileName); // Read DataBase
		void Preprocessing_DataBase(int minsup); // processing
		void Create_Boolean_Matrix(); // Create binary matrix
		void Create_Horizontal_DataBase(); // Initialise H
		void Create_Vertical_DataBase(); // Initialise V		
};

#endif // DEF_DATABASES
